unit set_data;

{$mode objfpc}{$H+}


interface

uses
  Classes, SysUtils, iniFiles, Graphics;

{$ifdef lib}
function        Set_FileName(Ext, Prog: String; Global, Subdir: Boolean): PChar; cdecl; external 'libset_data';
{$endif}

Type
{  TGlobal		          = record
    Dir			          : String;
    _set		          : boolean;
    end;                }
    
  TPConst                         = record
    fFilename{$ifdef lib}         : PChar;
    {$else ifndef lib},
    {$endif}
    fPath, fProg, Global, fExt    : String;
    end;

  TPStyle                         = record
    Font                          : array [0..10] of String;
    Color                         : array [0..10] of TColor;
    Global_set                    : boolean;
  end;

  TQR                             = record
    Link, Name                    : array [0..100] of String;
    last                          : byte;
    Genre                         : array [0..100] of array [0..2] of boolean;
  end;
  
{  TVeeJee_Master_File             = class
    PGlobal			  : TGlobal;
    PConst			  : TPConst;
  private
    function GetGlobal            : TGlobal;
    
    procedure SetGlobal(value: TGlobal);
  public
    constructor Create;
    destructor  Done;
    property	Global: TGlobal read GetGlobal write SetGlobal;
    end;        }
    
  {$if defined (VJ_Set)}
  TVeeJee_Set                     = class
    PConst                        : TPConst;
    fTSOL,                                      // TrayIcon Show on Load
    fPSOF                         : Boolean;    // PopUpMenü show on Form
    fDDir                         : String;     // Defaul dir
  private
    function GetTSOL: boolean;
    function GetPSOF: boolean;
    function GetDDir: String;


    procedure SetTSOL(Value: Boolean);
    procedure SetPSOF(Value: Boolean);
    procedure SetDDir(Value: String);
  public
    constructor Create;
    destructor Done;
    property TSOL: boolean read GetTSOL write SetTSOL default false;
    property PSOF: boolean read GetPSOF write SetPSOF default true;
    property DDir: String  read GetDDir write SetDDir;
  end;

  {$elseif defined (TrackFrame)}
  TVeeJee_OBS                     = Class
    PConst                        : TPConst;
    PStyle                        : TPStyle;
    fBG_Color, fT_Color           : TColor;
    T_Font                        : TFont;
    
  private
    Function GetBGColor: TColor;
    Function GetTColor: TColor;
    function GetFont: String;

    Procedure SetBGColor(Value: TColor);
    Procedure SetTColor(Value: TColor);
    procedure SetFont(Value: String);
  public
    constructor Create;
    destructor Done;
    property BG_Color: TColor read GetBGColor write SetBGColor default clPurple;
    property T_Color : TColor Read GetTColor  write SetTColor  default $001C78E9;
  end;
  {$endif}

  TVeeJee_QR4OBS                       = class
    PConst                             : TPConst;
    fQR_Data                           : TQR;
//    fUpDate                            : Boolean;
  private
    function    Get_QR_Data            : TQR;

    procedure   Set_QR_Data(Value      : TQR);
  public
    constructor Create;
    destructor  Done;
    property    QR_Data: TQR read Get_QR_Data write Set_QR_Data;
  end;
  
const
  MFD                             = 'VeeJee';

{$ifndef lib}
function        Set_FileName(Ext, Prog: String; Global, Subdir: Boolean): String;
{$endif}

implementation

{$ifndef lib}
function        Set_FileName(Ext, Prog: String; Global, SubDir: Boolean): String;
var Temp                          : String;
begin
  Temp                            := ExtractFilePath(GetAppConfigFile(Global, Subdir)) + Prog + PathDelim;
  Result                          := Format('%s%s', [temp, Ext]);
end;
{$endif}

{ TVeeJee }
    
{constructor TVeejee_Master_File.Create;
begin
  inherited;
  PConst.fExt			  := 'Settings';
  PConst.fProg			  := 'VeeJee';
  PConst.fFilename                := Set_FileName(PConst.fExt, PConst.fProg, false, false);
  if FileExists(PConst.fFileName+'GMF') then
    PGlobal		          := GetGlobal;
end;

destructor TVeeJee_Master_File.Done;
begin
  inherited;
end;

function  TVeeJee_Master_File.GetGlobal: TGlobal;
var s                             : String;
begin
  if FileExists(PConst.fFilename+'GMF') then begin
    with TIniFile.Create(PConst.fFileName+'GMF') do try
      s                           := 'Global Master File Settings';
      PGlobal.Dir		  := ReadString(s, 'GMD', '');
      PGlobal._set                := ReadBool(s, 'GMS_Set', false);
    finally
      Free;
      end;
    end;
    result                        := PGlobal;
  end;


procedure  TVeeJee_Master_File.SetGlobal(Value: TGlobal);
var s                             : String;
begin
  if FileExists(PConst.fFileName+'GMF') then DeleteFile(PConst.fFileName+'GMF');
  with TIniFile.Create(PConst.fFileName+'GMF') do try
    s                           := 'Global Master File Settings';
    WriteString(s, 'GMD', Value.Dir);
    WriteBool(s, 'GMD_Set', Value._set);
  finally
    Free;
    end;
end;                    }

{$if defined (VJ_Set)}

constructor TVeeJee_Set.Create;
begin
  inherited;
  PConst.fExt                     := 'Settings';
  PConst.fProg                    := 'VeeJee-Live';
  //  PConst.fPath               := ExtractFilePath(GetAppConfigFile(false, false)) + PConst.fProg + PathDelim;
  //  PConst.fFilename           := Format('%s%s', [PConst.fPath, PConst.fExt]);
    PConst.fFilename              := Set_FileName(PConst.fExt, PConst.fProg, false, false);
  if FileExists(PConst.fFileName+'.tsol') then
    fTSOL                         := GetTSOL;
  if FileExists(PConst.fFileName+'.psof') then
    fPSOF                         := GetPSOF;
end;

destructor TVeeJee_Set.Done;
begin
  inherited;
end;

function TVeeJee_Set.GetTSOL: boolean;
begin
  if FileExists(PConst.fFileName+'.tsol') then begin
    with TIniFile.Create(PConst.fFileName+'.tsol') do try
        fTSOL                     := ReadBool('TrayShow', 'TrayShowOnLoad', False);
    finally
      Free;
      end;
  end;
  Result                          := fTSOL;
end;

function TVeeJee_Set.GetPSOF: boolean;
begin
  if FileExists(PConst.fFileName+'.psof') then begin
    with TIniFile.Create(PConst.fFileName+'.psof') do try
        fPSOF                     := ReadBool('PopUp', 'PupUpShowOnForm', True);
    finally
      Free;
      end;
    end;
  Result                          := fPSOF;
end;

function TVeeJee_Set.GetDDir: String;
begin
  if FileExists(PConst.fFileName+'.ddir') then begin
    with TIniFile.Create(PConst.fFileName+'.ddir') do try
        fDDir                     := ReadString('Directory of VJ-Files', 'DDIR', '');
    finally
      Free;
      end;
    end;
  Result                          := fDDir;
end;

procedure TVeeJee_Set.SetTSOL(Value: Boolean);
begin
  if FileExists(PConst.fFileName+'.tsol') then DeleteFile(PConst.fFileName+'.tsol');
  with TIniFile.Create(PConst.fFileName+'.tsol') do try
      WriteBool('TrayShow', 'TrayShowOnLoad', Value);
  finally
    Free;
    end;
end;

procedure TVeeJee_Set.SetPSOF(Value: boolean);
begin
  if FileExists(PConst.fFileName+'.psof') then DeleteFile(PConst.fFileName+'.psof');
  with TIniFile.Create(PConst.fFileName+'.psof') do try
      WriteBool('PopUp', 'PopupShowOnForm', Value);
  finally
    Free;
    end;
end;

procedure TVeeJee_Set.SetDDir(Value: String);
begin
  if FileExists(PConst.fFileName+'.ddir') then DeleteFile(PConst.fFileName+'.ddir');
  with TIniFile.Create(PConst.fFileName+'.ddir') do try
      WriteString('Directory of VJ-Files', 'DDIR', Value);
  finally
    Free;
    end;
end;

{$endif}

{ VeeJee OBS }

{$if defined (TrackFrame)}

constructor TVeeJee_OBS.Create;
begin
  inherited;
  PConst.fExt                     := 'Settings';
  PConst.fProg                    := 'VeeJee-OBS';
//  PConst.fPath               := ExtractFilePath(GetAppConfigFile(false, false)) + PConst.fProg + PathDelim;
//  PConst.fFilename           := Format('%s%s', [PConst.fPath, PConst.fExt]);
  PConst.fFilename                := Set_FileName(PConst.fExt, PConst.fProg, false, false);
  if FileExists(PConst.fFileName+'.BG_Color') then
    fBG_Color                     := GetBGColor;
  if FileExists(PConst.fFileName+'.T_Color') then
    fT_Color                      := GetTColor;
end;

destructor TVeeJee_OBS.Done;
begin
  inherited;
end;

function TVeeJee_OBS.GetBGColor: TColor;
begin
  if FileExists(PConst.fFileName+'.BG_Color') then begin
    with TIniFile.Create(PConst.fFileName+'.BG_Color') do try
        BG_Color             := StringToColor(ReadString('Frame-Color', 'BG_Color', 'clPurple'));
    finally
      Free;
      end;
  end;
  Result                          := BG_Color;
end;

function TVeeJee_OBS.GetTColor: TColor;
begin
  if FileExists(PConst.fFileName+'.T_Color') then begin
    with TIniFile.Create(PConst.fFileName+'.T_Color') do try
        T_Color                   := StringToColor(ReadString('Frame-Color', 'T_Color', '$001C78E9'));
    finally
      Free;
      end;
  end;
  Result                          := T_Color;
end;

function TVeeJee_OBS.GetFont: String;
begin

end;

procedure TVeeJee_OBS.SetBGColor(Value: TColor);
begin
  if FileExists(PConst.fFileName+'.BG_Color') then DeleteFile(PConst.fFileName+'.BG_Color');
  with TIniFile.Create(PConst.fFileName+'.BG_Color') do try
      WriteString('Frame-Color', 'BG_Color', ColorToString(Value));
  finally
    Free;
    end;
end;

procedure TVeeJee_OBS.SetTColor(Value: TColor);
begin

end;

procedure TVeeJee_OBS.SetFont(Value: String);
begin

end;

{$endif}

{ VeeJee_QR4OBS }

{#todo -QR als Typ alegen. }
{#done -> QR : Array[0..100] of Record}
{#todo -get und Set im QR umschreiben, das bis zu 1024 werte möglich sind; Alternativ Offenes Array}
{#done 30.09 get set umlagern}
{#todo 01.10. settings globalisieren (Mastetprojekt "VeeJee")}
{#todo 01.10. alle module im master als prozessn starten}

constructor TVeeJee_QR4OBS.Create;
begin
  inherited;
  PConst.fExt                          := 'QR-List';
  PConst.fProg                         := 'QR4OBS';
//  PConst.fPath                       := ExtractFilePath(GetAppConfigFile(false, false)) + PConst.fProg + PathDelim;
//  PConst.fFilename                   := Format('%s%s', [PConst.fPath, PConst.fExt]);
//  {$ifdef lib}
//  PConst.fFilename                     := Set_FileName(PConst.fExt, PConst.fProg, false, false);
//  {$else}
  PConst.fFilename                     := Set_FileName(PConst.fExt, PConst.fProg, false, false);
//  {$endif}
  if NOT (fileExists(PConst.fFileName+'.QRD')) then begin

 //    VamLykTan
     fQR_Data.Link[10]                 := 'https://www.paypal.com/donate/?hosted_button_id=JWHXZ5MATXQY6';
     fQR_Data.Name[10]                 := '--> Donate <--';
     fQR_Data.Genre[10][0]             := true;
     fQR_Data.Genre[10][1]             := true;

     fQR_Data.Link[20]                 := 'https://www.facebook.com/profile.php?id=100063754892757';
     fQR_Data.Name[20]                 := '--> VamLykTan @ Facebook <--';
     fQR_Data.Genre[20][0]             := true;
     fQR_Data.Genre[20][1]             := true;

     fQR_Data.Link[30]                 := 'https://www.mixcloud.com/VamLykTan/';
     fQR_Data.Name[30]                 := '--> VamLykTan @ Mixcloud <--';
     fQR_Data.Genre[30][0]             := true;
     fQR_Data.Genre[30][1]             := true;

 //    Twitch-Kanäle

     fQR_Data.Link[40]                 := 'https://www.twitch.tv/scareful_tv';
     fQR_Data.Name[40]                 := '--> Scareful_TV @ Twitch <--';
     fQR_Data.Genre[40][0]             := true;
     fQR_Data.Genre[40][1]             := true;

     fQR_Data.Link[50]                 := 'https://www.twitch.tv/riderscafe';
     fQR_Data.Name[50]                 := '--> Rider''s Cafe Lübeck <--';
     fQR_Data.Genre[50][0]             := true;
     fQR_Data.Genre[50][1]             := true;

 // Band Support

     fQR_Data.Link[60]                 := 'https://www.youtube.com/@aeongods';
     fQR_Data.Name[60]                 := '--> Aeon Gods @ Youtube <--';
     fQR_Data.Genre[60][0]             := true;
     fQR_Data.Genre[60][1]             := false;

     fQR_Data.Link[70]                 := 'https://www.youtube.com/@Metamorphonia';
     fQR_Data.Name[70]                 := ' --> Metamorphonia @ Youtube <--';
     fQR_Data.Genre[70][0]             := true;
     fQR_Data.Genre[70][1]             := true;

     fQR_Data.Link[80]                 := 'https://www.youtube.com/channel/UCIf95feGC4ue8FdDwYPbM4g';
     fQR_Data.Name[80]                 := '--> Torment of Tantalos @ Youtube <--';
     fQR_Data.Genre[80][0]             := true;
     fQR_Data.Genre[80][1]             := false;

     fQR_Data.Link[90]                 := 'https://www.youtube.com/@bel_epoq';
     fQR_Data.Name[90]                 := '--> Bel Epog @ Youtube <--';
     fQR_Data.Genre[90][0]             := true;
     fQR_Data.Genre[90][1]             := true;

     fQR_Data.Link[100]                := 'https://www.youtube.com/@Band.gegentakt';
     fQR_Data.Name[100]                := '--> Gegentakt @ Youtube <--';
     fQR_Data.Genre[100][0]            := true;
     fQR_Data.Genre[100][1]            := false;

     Set_QR_Data(fQR_Data);
     end;

end;

destructor  TVeeJee_QR4OBS.Done;
begin
  inherited;
end;

function    TVeeJee_QR4OBS.Get_QR_Data: TQR;
var id, ig                             : byte;
    s                                  : String;
begin
  if FileExists(PConst.fFilename+'.QRD') then begin
    with TIniFile.Create(PConst.fFileName+'.QRD') do try
        for id:= 0 to 100 do begin
          s                            := 'CR-Code: ' + IntToStr(id);
          fQR_Data.Link[id]            := ReadString(s, 'QR-Link', '');
          if length(fQR_Data.Link[id]) > 5 then begin
            fQR_Data.Name[id]          := ' ' + ReadString(s, 'Name zum QR-Link', '') + ' ';
            for ig := 0 to 2 do
              fQR_Data.Genre[id][ig]   := ReadBool(s, 'QR-Genre: ' + IntToStr(ig), false);
            fQR_Data.last              := id + 1;
            end;
          end;
    finally
      free
      end;
    end;
  result                               := fQR_Data;
end;

procedure   TVeeJee_QR4OBS.Set_QR_Data(Value: TQR);
var id, id2, ig                        : byte;
    s                                  : String;
begin
  id2                                  := 0;
  if FileExists(PConst.fFileName+'.QRD') then DeleteFile(PConst.fFileName+'.QRD');
  with TIniFile.Create(PConst.fFileName+'.QRD') do try
    for id := 0 to 100 do begin
      if length(fQR_Data.Link[id]) > 5 then begin
        s                         := 'CR-Code: ' + IntToStr(id2);
        WriteString(s, 'QR-Link', Value.Link[id]);
        WriteString(s, 'Name zum QR-Link', Value.Name[id]);
        for ig := 0 to 2 do
          WriteBool(s, 'QR-Genre: ' + IntToStr(ig), Value.Genre[id][ig]);
        inc(id2);
        end;
      end;
//    WriteBool('END OF FILE: ', 'fUpDate: := ',  True);
//    fUpDate                            := True;
  finally
    Free;
  end;
end;

end.
